// GPDefSem.cs                                              HDO, 2006-08-28
// -------------
// Semantic evaluator for table-driven top-down parsing.
// Generated by Coco-2 (PGT).
//=====================================|========================================

using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;

using Lex = GPDefLex;
using Syn = GPDefSyn;

public class GPDefSem {


  public const String MODULENAME = "GPDefSem";

  public static void GPDefSemMethod(Utils.ModuleAction action, out String moduleName) {
  //-----------------------------------|----------------------------------------
    moduleName = MODULENAME;
    switch (action) {
      case Utils.ModuleAction.getModuleName:
        return;
      case Utils.ModuleAction.initModule:
        break;
      case Utils.ModuleAction.resetModule:
        break;
      case Utils.ModuleAction.cleanupModule:
        return;
    } // switch
  } // GPDefSemMethod


  // *** start of global SYN and SEM declarations from ATG ***
  
  static StringBuilder srcText;
  public static HeuristicLab.Optimization.IProblem problem;

  // *** end of global SYN and SEM declarations from ATG ***

  
  private static void P_source() {
    Lex.GETsourceAttr();
    GPDefSem.srcText = new StringBuilder();
    for (; ; ) {
     switch (GPDefLex.curCh) {
       case Utils.EF:
         Errors.SemError(GPDefLex.curLine, GPDefLex.curCol, "end of file in source text");
         return;
       case '<':
         GPDefLex.NextCh();
         if (GPDefLex.curCh == '<') {
           GPDefSem.srcText.Append('<');
           Errors.Warning(GPDefLex.curLine, GPDefLex.curCol, "non closed source text before?");
           GPDefLex.NextCh();
         }
         GPDefSem.srcText.Append('<');
         break;
       case '>':
         GPDefLex.NextCh();
         if (GPDefLex.curCh == '>') {
           GPDefLex.curCh = ' ';          // force GPDefLex to get next character
           SourceReader.Handle(GPDefSem.srcText.ToString());
           return;
         }
         GPDefSem.srcText.Append('>');
         break;
       default:
         GPDefSem.srcText.Append(GPDefLex.curCh);
         GPDefLex.NextCh();
         break;
     }
    }

  } // P_source


  private static void NT_GPDef() {
    string identStr = "";
    RuleNode ruleNode = null;
    GPDefNode gpDef = new GPDefNode();
    NonTerminalNode ntNode = null;
    FitnessFunctionNode fitnessFunNode = null;
    TerminalNode tNode = null;
    problem = null;

    for (;;) {
      switch (Syn.Interpret()) {
        case 0:
          return;
        case 1:
          Lex.GETidentAttr(out identStr);
          break;
        case 2: // SEM
          gpDef.Name = identStr;
          break;
        case 3: // SEM
          SourceReader.WithNext((src) => gpDef.ClassCodeNode = new CodeNode{SrcCode = src});
          break;
        case 4: // SEM
          SourceReader.WithNext((src) => gpDef.InitCodeNode = new CodeNode{SrcCode = src});
          break;
        case 5:
          NT_NonterminalDecl(out ntNode);
          break;
        case 6: // SEM
          gpDef.NonTerminals.Add(ntNode);
          break;
        case 7:
          NT_TerminalDecl(out tNode);
          break;
        case 8: // SEM
          gpDef.Terminals.Add(tNode);
          break;
        case 9:
          NT_RuleDef(out ruleNode);
          break;
        case 10: // SEM
          gpDef.Rules.Add(ruleNode);
          break;
        case 11: // SEM
          fitnessFunNode = new FitnessFunctionNode();
          gpDef.FitnessFunctionNode = fitnessFunNode;

          break;
        case 12: // SEM
          fitnessFunNode.Maximization = true;
          break;
        case 13: // SEM
          fitnessFunNode.Maximization = false;
          break;
        case 14: // SEM
          SourceReader.WithNext((src) => fitnessFunNode.SrcCode = src);
          break;
        case 15:
          Lex.GETidentAttr(out identStr);
          break;
        case 16: // SEM
          SourceReader.Handle(GPDefSem.srcText.ToString()); // flush the source reader
          var gen = new ProblemGenerator();
          problem = gen.GenerateFromAst(gpDef);

          break;
      } // switch
    } // for
  } // NT_GPDef

  private static void NT_SemAction(out RuleActionNode action) {
    RuleActionNode myAction = null; action = null;
    for (;;) {
      switch (Syn.Interpret()) {
        case 0:
          return;
        case 1: // SEM
          myAction = new RuleActionNode();
          SourceReader.WithNext((src) => {myAction.SrcCode = src;});
          action = myAction;

          break;
      } // switch
    } // for
  } // NT_SemAction

  private static void NT_NonterminalDecl(out NonTerminalNode ntNode) {
    string identStr = ""; ntNode = null;
    for (;;) {
      switch (Syn.Interpret()) {
        case 0:
          return;
        case 1:
          Lex.GETidentAttr(out identStr);
          break;
        case 2: // SEM
          var myNtNode = new NonTerminalNode();
          ntNode = myNtNode;
          myNtNode.Ident = identStr;
          SourceReader.WithNext((src) => {myNtNode.FormalParameters = src;});

          break;
      } // switch
    } // for
  } // NT_NonterminalDecl

  private static void NT_TerminalDecl(out TerminalNode tNode) {
    string identStr = "";
    tNode = null;
    TerminalNode myTNode = null;
    IEnumerable<ConstraintNode> constraints = null;

    for (;;) {
      switch (Syn.Interpret()) {
        case 0:
          return;
        case 1:
          Lex.GETidentAttr(out identStr);
          break;
        case 2: // SEM
          myTNode = new TerminalNode();
          tNode = myTNode;
          myTNode.Ident = identStr;
          SourceReader.WithNext((src) => {
            myTNode.FormalParameters = src;
            myTNode.FieldDefinitions = SourceReader.ExtractFormalParameters(src);
          });
          

          break;
        case 3:
          NT_ConstraintDef(out constraints);
          break;
        case 4: // SEM
          myTNode.Constraints = constraints;
          break;
      } // switch
    } // for
  } // NT_TerminalDecl

  private static void NT_ConstraintDef(out IEnumerable<ConstraintNode> constraints) {
    List<ConstraintNode> constraintsList = new List<ConstraintNode>();
    ConstraintNode n = null;
    constraints = null;

    for (;;) {
      switch (Syn.Interpret()) {
        case 0:
          return;
        case 1:
          NT_ConstraintRule(out n);
          break;
        case 2: // SEM
          constraintsList.Add(n);
          break;
        case 3: // SEM
          constraints = constraintsList;
          break;
      } // switch
    } // for
  } // NT_ConstraintDef

  private static void NT_ConstraintRule(out ConstraintNode constraint) {
    string identStr = null;
    constraint = null;

    for (;;) {
      switch (Syn.Interpret()) {
        case 0:
          return;
        case 1:
          Lex.GETidentAttr(out identStr);
          break;
        case 2: // SEM
          constraint = new ConstraintNode(identStr);
          break;
        case 3:
          NT_SetDefinition(constraint);
          break;
        case 4: // SEM
          SourceReader.Handle(GPDefSem.srcText.ToString()); // flush the source reader
          break;
      } // switch
    } // for
  } // NT_ConstraintRule

  private static void NT_SetDefinition(ConstraintNode constraint) {
    for (;;) {
      switch (Syn.Interpret()) {
        case 0:
          return;
        case 1: // SEM
          constraint.Type = ConstraintNodeType.Set;
          break;
        case 2: // SEM
          SourceReader.WithNext((src) => {constraint.SetExpression = src;});
          break;
        case 3: // SEM
          constraint.Type = ConstraintNodeType.Range;
          break;
        case 4: // SEM
          SourceReader.WithNext((src) => {constraint.RangeMinExpression = src;});
          break;
        case 5: // SEM
          SourceReader.Handle(GPDefSem.srcText.ToString()); // flush the source reader
          SourceReader.WithNext((src) => {constraint.RangeMaxExpression = src;});
          break;
      } // switch
    } // for
  } // NT_SetDefinition

  private static void NT_RuleDef(out RuleNode rule) {
    RuleExprNode expr = null;
    string identStr = null;
    RuleNode myRule = null;
    rule = null;

    for (;;) {
      switch (Syn.Interpret()) {
        case 0:
          return;
        case 1:
          Lex.GETidentAttr(out identStr);
          break;
        case 2: // SEM
          myRule = new RuleNode();
          rule = myRule;
          myRule.NtSymbol = identStr;

          break;
        case 3: // SEM
          SourceReader.WithNext((src) => {myRule.LocalCode = src;});

          break;
        case 4:
          NT_SynExpr(out expr);
          break;
        case 5: // SEM
          myRule.RuleExpr = expr;

          break;
      } // switch
    } // for
  } // NT_RuleDef

  private static void NT_SynExpr(out RuleExprNode expr) {
    expr = null;
    AlternativesNode alt = null;

    for (;;) {
      switch (Syn.Interpret()) {
        case 0:
          return;
        case 1:
          NT_SynTerm(out expr);
          break;
        case 2: // SEM
          alt = new AlternativesNode();
          alt.Add(expr);

          break;
        case 3:
          NT_SynTerm(out expr);
          break;
        case 4: // SEM
          alt.Add(expr); expr = alt;
          break;
      } // switch
    } // for
  } // NT_SynExpr

  private static void NT_SynTerm(out RuleExprNode expr) {
    SequenceNode seq = null; expr = null;
    for (;;) {
      switch (Syn.Interpret()) {
        case 0:
          return;
        case 1:
          NT_SynFact(out expr);
          break;
        case 2: // SEM
          seq = new SequenceNode();
          seq.Add(expr);

          break;
        case 3:
          NT_SynFact(out expr);
          break;
        case 4: // SEM
          seq.Add(expr); expr = seq;
          break;
      } // switch
    } // for
  } // NT_SynTerm

  private static void NT_SynFact(out RuleExprNode expr) {
    string identStr = "";
    RuleActionNode action = null;
    expr = null;

    for (;;) {
      switch (Syn.Interpret()) {
        case 0:
          return;
        case 1:
          Lex.GETidentAttr(out identStr);
          break;
        case 2: // SEM
          var callNode = new CallSymbolNode{Ident = identStr};
          SourceReader.WithNext((src) => {callNode.ActualParameter = src;});
          expr = callNode;

          break;
        case 3:
          NT_SemAction(out action);
          break;
        case 4: // SEM
          expr = action;
          break;
      } // switch
    } // for
  } // NT_SynFact


  public delegate void PragmaMethod();
  public static PragmaMethod[] pragmaMethods = {
      new PragmaMethod(P_source)
    };


  public static void StartSem() {
  //-----------------------------------|----------------------------------------
    for (;;) {
      switch (Syn.Interpret()) {
        case 0:
          return;
        case 1:
          NT_GPDef();
          break;
      } // switch
    } // for
  } // StartSem

    
} // GPDefSem

// End of GPDefSem.cs
//=====================================|========================================
